package se.sjv.integration.test.trace;

import javax.enterprise.inject.Produces;
import javax.enterprise.inject.spi.InjectionPoint;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class LoggerProducer {

    /**
     * Producerar en Slf4j Logger instans. Instansen kommer att hämtas med samma
     * namn som den klass där loggern injectas (fullständigt klassnamn).
     *
     * @param injectionPoint - {@link InjectionPoint}.
     * @return {@link Logger}
     */
    @Produces
    public Logger produceLog(final InjectionPoint injectionPoint) {
        System.out.println("injectionPoint: " + injectionPoint);
        if(injectionPoint != null){
            System.out.println("injectionPoint: " + injectionPoint.getMember());
        }
        
      Class<?> clazz = injectionPoint.getMember().getDeclaringClass();

      return LoggerFactory.getLogger(clazz);
    }
}